#include <AppKit.h>
#include <InterfaceKit.h>


#define GO_MESSAGE 'MiGo'


class MyWin : public BWindow {
public:
	MyWin(BRect rect) : BWindow(rect, "MenuFieldTest", B_TITLED_WINDOW
		, B_QUIT_ON_WINDOW_CLOSE | B_ASYNCHRONOUS_CONTROLS) {

		_CreateView(Bounds());

	}


	virtual void MessageReceived(BMessage* message) {
		switch (message->what) {
			case GO_MESSAGE:
				{
					BView* containerView = ChildAt(0);

					if (containerView) {

						containerView->LockLooper();

						containerView->RemoveSelf();

						//This delete hangs approximately 1 out of every 6-8 tries
						//The menufield is stalled at wait_for_thread() in it's destructor
						//because _m_task_ won't exit properly
						delete containerView;

						//Uncomment the following _CreateView() to hang immediately
						//This one does weird things as well, I assume it's related
						//_CreateView(Bounds());
					}
				}
				break;
			default:
				BWindow::MessageReceived(message);
		}
	}


	void _CreateView(BRect rect) {
		BView* containerView = new BView(Bounds(), NULL, B_FOLLOW_ALL_SIDES, 0);

		AddChild(containerView);

		BMenu* menu = new BMenu("Menu");

		menu->AddItem(new BMenuItem("Go", new BMessage(GO_MESSAGE)));

		containerView->AddChild(new BMenuField(BRect(0, 0, 200, 200)
									, "MenuField", "TestMenuField", menu));
	}
};


class MyApp : public BApplication {
public:
	MyApp() : BApplication("application/x-vnd.cpr-mftest") {
		MyWin* win = new MyWin(BRect(200, 200, 400, 400));

		win->Show();
	}
};


int main(int argc, char** argv) {
	MyApp app;

	app.Run();

	return 0;
}
